#pragma semicolon 1
#include <sourcemod>
#include <shop>
#pragma semicolon 1

public Plugin:myinfo =
{
	name = "[Shop] Vampirism",
	author = "R1KO",
	version = "1.1",
	url = "http://hlmod.ru/"
};

new bool:g_bHasVampirism[MAXPLAYERS+1];

new g_iPrice,
	g_iSellPrice,
	g_iDuration,
	g_iMaxHp,
	Float:g_fPercentage,
	ItemId:id,
	m_iHealth;

public OnPluginStart()
{
	decl Handle:hCvar;
	
	HookConVarChange((hCvar = CreateConVar("sm_shop_vampirism_price", "1000", "Стоимость покупки вампиризма.")), OnPriceChange);
	g_iPrice = GetConVarInt(hCvar);

	HookConVarChange((hCvar = CreateConVar("sm_shop_vampirism_sellprice", "1000", "Стоимость продажи вампиризма.")), OnSellPriceChange);
	g_iSellPrice = GetConVarInt(hCvar);

	HookConVarChange((hCvar = CreateConVar("sm_shop_vampirism_duration", "86400", "Длительность вампиризма в секундах.")), OnDurationChange);
	g_iDuration = GetConVarInt(hCvar);

	HookConVarChange((hCvar = CreateConVar("sm_shop_vampirism_percentage", "30.0", "Сколько процентов от нанесенного урона будет переходить в хп атакующему", 0, true, 1.0, true, 100.0)), OnPercentageChange);
	g_fPercentage = GetConVarFloat(hCvar)/100.0;
	
	HookConVarChange((hCvar = CreateConVar("sm_shop_vampirism_max_hp", "150", "Максимальное кол-во хп.")), OnMaxHpChange);
	g_iMaxHp = GetConVarInt(hCvar);

	AutoExecConfig(true, "shop_vampirism", "shop");

	HookEvent("player_hurt", Event_OnPlayerHurt);

	m_iHealth = FindSendPropOffs("CCSPlayer", "m_iHealth");

	if (Shop_IsStarted()) Shop_Started();
}

public OnPriceChange(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	g_iPrice = GetConVarInt(hCvar);
	if(id != INVALID_ITEM)
	{
		Shop_SetItemPrice(id, g_iPrice);
	}
}

public OnSellPriceChange(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	g_iSellPrice = GetConVarInt(hCvar);
	if(id != INVALID_ITEM)
	{
		Shop_SetItemSellPrice(id, g_iSellPrice);
	}
}

public OnDurationChange(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	g_iDuration = GetConVarInt(hCvar);
	if(id != INVALID_ITEM)
	{
		Shop_SetItemValue(id, g_iDuration);
	}
}

public OnPercentageChange(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	g_fPercentage = GetConVarFloat(hCvar)/100.0;
}

public OnMaxHpChange(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	g_iMaxHp = GetConVarInt(hCvar);
}

public OnClientPutInServer(iClient)
{
	g_bHasVampirism[iClient] = false;
}

public OnPluginEnd() Shop_UnregisterMe();

public Shop_Started()
{
	new CategoryId:category_id = Shop_RegisterCategory("ability", "Способности", "");
	
	if (Shop_StartItem(category_id, "vampirism"))
	{
		Shop_SetInfo("Вампиризм", "", g_iPrice, g_iSellPrice, Item_Togglable, g_iDuration);
		Shop_SetCallbacks(OnItemRegistered, OnItemUsed, _, OnItemDisplay);
		Shop_EndItem();
	}
}

public OnItemRegistered(CategoryId:category_id, const String:category[], const String:item[], ItemId:item_id) id = item_id;

public bool:OnItemDisplay(client, CategoryId:category_id, const String:category[], ItemId:item_id, const String:item[], ShopMenu:menu, &bool:disabled, const String:name[], String:buffer[], maxlen)
{
	FormatEx(buffer, maxlen, "Вампиризм [%.0f %%]", g_fPercentage*100.0);
	return true;
}

public ShopAction:OnItemUsed(iClient, CategoryId:category_id, const String:category[], ItemId:item_id, const String:item[], bool:isOn, bool:elapsed)
{
	if (isOn || elapsed)
	{
		g_bHasVampirism[iClient] = false;
		return Shop_UseOff;
	}

	g_bHasVampirism[iClient] = true;

	return Shop_UseOn;
}

public Event_OnPlayerHurt(Handle:hEvent, const String:name[], bool:dontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "attacker"));
	if (iClient && g_bHasVampirism[iClient] && IsPlayerAlive(iClient))
	{
		new iHealth = GetEntData(iClient, m_iHealth) + RoundFloat(float(GetEventInt(hEvent, "dmg_health"))*g_fPercentage);
		if(iHealth > g_iMaxHp)
		{
			iHealth = g_iMaxHp;
		}

		SetEntData(iClient, m_iHealth, iHealth);
	}
}